unit PCI;
{}
            interface
{}
const
  PCISuccesful=0;

function PCIFindDevice(Class:longint; Index:word;
                       var BusNumber, DevFnNumber:byte):byte;
function PCIReadByte(BusNumber, DevFnNumber:byte; Address:word):byte;
function PCIReadWord(BusNumber, DevFnNumber:byte; Address:word):word;

{}
          implementation
{}

function PCIFindDevice(Class:longint; Index:word;
                    var BusNumber, DevFnNumber:byte):byte; assembler;
asm
  mov ax, 0b103h
  db 66h; mov cx, word ptr Class { <-- ⢥ ࠤ ⮣   }
  mov si, Index                  { ᯮ짮 Asm.                  }
  int 1ah
  les si, dword ptr BusNumber
  mov byte ptr es:[si], bh
  les si, dword ptr DevFnNumber
  mov byte ptr es:[si], bl
  mov al, ah
  xor ah, ah
end;

function PCIReadByte(BusNumber, DevFnNumber:byte; Address:word):byte; assembler;
asm
  mov ax, 0b108h
  mov bh, BusNumber
  mov bl, DevFnNumber
  mov di, Address
  int 1ah
  xor ah, ah
  mov al, cl
end;

function PCIReadWord(BusNumber, DevFnNumber:byte; Address:word):word; assembler;
asm
  mov ax, 0b109h
  mov bh, BusNumber
  mov bl, DevFnNumber
  mov di, Address
  int 1ah
  mov ax, cx
end;

end.